/*
 * Example: Publish a topic and message as JSON format
 * Author: Akinori Tsuji
 */
import se.goransson.mqtt.*;
import processing.serial.*;

MQTT mqtt;
Serial myPort;

void setup() {
  myPort = new Serial(this, "COM5", 19200);
  myPort.bufferUntil('\n');

  mqtt = new MQTT( this );
  mqtt.connect( "web.is.tokushima-u.ac.jp", 1883, "mosquitto-unique-id" );
}

void draw() {
}

float floatFormat(float num, int n ) {
  float _pow = pow( 10, n ) ;
  return round( num * _pow ) / _pow ;
}

String ED;
int SW;
float ID, BA, A1, A2, TM, HM, AT;
float LX;

void serialEvent(Serial myPort) {
  String myString = myPort.readStringUntil('\n');
  if (myString != null) {
    myString = trim(myString);
    String Data1[] = split(myString, ':');
    if (Data1.length >= 9) {
      String ed[] = split(Data1[1], '=');
      if (ed[0].equals("ed")) {
        ED = ed[1];
      }
      String id[] = split(Data1[2], '=');
      if (id[0].equals("id")) {
        ID = float(id[1]);
      }
      String ba[] = split(Data1[3], '=');
      if (ba[0].equals("ba")) {
        BA = float(ba[1]);
      }
      String a1[] = split(Data1[4], '=');
      if (a1[0].equals("a1")) {
        A1 = float(a1[1]);
        if (A1 > 1000) {
          SW = 0;
        } else {
          SW = 1;
        }
      }
      String a2[] = split(Data1[5], '=');
      if (a2[0].equals("a2")) {
        A2 = float(a2[1]);
        LX = A2*222.0*BA/1024.0; //lux
      }
      String tm[] = split(Data1[6], '=');
      if (tm[0].equals("tm")) {
        TM = float(tm[1])/100;
      }
      String hm[] = split(Data1[7], '=');
      if (hm[0].equals("hu")) {
        HM = float(hm[1])/100;
      }
      String at[] = split(Data1[8], '=');
      if (at[0].equals("at")) {
        AT = float(at[1]);
      }

      println(ED);
      println(ID);
      println(BA);
      println(SW);
      println(LX);
      println(TM);
      println(HM);
      println(AT);
      println();

      String message = "{\"temp\": " + str(TM) + ", \"humid\": " + str(HM) + ", \"alt\": " + str(AT) + ", \"sw\": " + str(SW) + ", \"lux\": " + str(LX) + "}";
      // publish with topic and message
      mqtt.publish( "/koukai/", message ); // ID

      myPort.clear();
    }
  }
}